
Figure - Bug #115036
【BSP】【EVT2】【偶现】通过蓝牙设备后台播放音乐，切换蓝牙耳机后，音乐停止播放
2023-01-03 21:01 - CDTS_TEST 刘勇

Status: CLOSED Start date:

Priority: Normal Due date:

Assignee: CD TPM-王祥林 % Done: 100%

Category: AUDIO-FW Estimated time: 0.00 hour

Target version: VC1_FSE_0086_20230328

Need_Info: -- Found Version: FlatBuild_HH_VX1_MCE_FSE.M.D.user.01.00.X101.202212310352

Resolution: INVALID Degrated: --

Severity: Normal Verified Version:

Reproducibility: Occasionally Fixed Version:

Test Type: ST Root cause: 未复现

Description

【前提条件】

设备刷机

【测试步骤】

1、push 两首mp3格式歌曲在设备 /sdcard/Download/中

2、连接2个BT耳机、1个蓝牙手柄

3、进入音乐APK ->播放音乐->上划返回桌面让音乐在后台运行

4、进入"设置"->"已连接的设备"—>点击"另1个蓝牙耳机"

【预期结果】

5. 音乐正常播放，从选择的蓝牙耳机中播放

【实际结果】

5. 音乐停止播放、控制中心音乐播放界面无音乐

【复现概率】

1/6

【发生时间】在log的20221231-04：54：39前1分钟内

History

#1 - 2023-01-04 17:28 - CDTS-TEST 周婷

- Category changed from CD-APP to AUDIO-FW

#2 - 2023-01-05 17:37 - CD MM陈海波

- Start date changed from 2023-01-03 to 2023-01-20

#3 - 2023-01-05 17:37 - CD MM陈海波

- Due date set to 2023-01-19

- Start date deleted (2023-01-20)

#4 - 2023-01-06 17:00 - CD MM陈海波

- Status changed from New to ASSIGNED

从log分析, 音乐停止主要还是systemui 发送了消息, 获取到了音频焦点, 

导致播放的音乐暂停了.
具体的log如下: 

12-31 04:47:27.713  1488  6150 I MediaFocusControl: requestAudioFocus() from uid/pid 10089/7461 AA=USAGE_MEDIA/CONTENT_TYPE_MUSIC

clientId=android.media.AudioManager@218de0dcom.android.music.MediaPlaybackService$4@34cb1c2 callingPack=com.android.music req=1 flags=0x0

sdk=31

12-31 04:47:27.800   805  8051 D audio_hw_primary: start_output_stream: enter: stream(0xecb0eb00)usecase(3: compress-offload-playback) devices(0x80)

is_haptic_usecase(0)

12-31 04:47:28.135   805  8051 D audio_hw_primary: start_output_stream: exit

12-31 04:48:57.850   805  4540 D audio_hw_primary: start_output_stream: enter: stream(0xecb04330)usecase(1: low-latency-playback) devices(0x80)

is_haptic_usecase(0)

12-31 04:48:57.875   805  4540 D audio_hw_primary: start_output_stream: exit

12-31 04:48:57.971  1488  4658 I MediaFocusControl: requestAudioFocus() from uid/pid 10081/1954

AA=USAGE_NOTIFICATION/CONTENT_TYPE_SONIFICATION clientId=android.media.AudioManager@e95a65d callingPack=com.android.systemui

req=3 flags=0x0 sdk=31

但既然systmeui 发送了消息, 那么会听到一个消息音才对. 

正在和测试小伙伴确认进一步的信息.

如果是音乐暂停, 当消息未响起, 那还需要从audio侧研究下, 是否为正常的设计.

多谢!

#5 - 2023-01-17 20:31 - CD MM陈海波

- Category changed from AUDIO-FW to BSP

- Assignee changed from CD MM陈海波 to CD BSP何伟

从log进行分析, 应该是driver堵塞住了. 

需要audio bsp查看下堵塞的原因.

具体的log: 

12-31 04:47:27.713  1488  6150 I MediaFocusControl: requestAudioFocus() from uid/pid 10089/7461 AA=USAGE_MEDIA/CONTENT_TYPE_MUSIC

clientId=android.media.AudioManager@218de0dcom.android.music.MediaPlaybackService$4@34cb1c2 callingPack=com.android.music req=1 flags=0x0

sdk=31

12-31 04:47:28.141   805  8051 D audio_hw_primary: No space available in compress driver, post msg to cb thread

12-31 04:47:28.800   805  8051 D audio_hw_primary: No space available in compress driver, post msg to cb thread

12-31 04:47:29.607   805  8051 D audio_hw_primary: No space available in compress driver, post msg to cb thread

堵住的原因很大可能和下边的log相关: 

12-31 04:45:48.989   805  1718 D audio_hw_primary: adev_set_parameters: enter: reconfigA2dp=true

12-31 04:45:48.989   805  1718 D audio_hw_primary: reconfigure a2dp... forcing device switch

12-31 04:45:48.989   805  1718 D audio_hw_primary: Switching to speaker and muting the stream before select_devices

这个log产生的原因主要是蓝牙模块频繁调用audio接口setParameter接口(reconfigA2dp=true). 
因为需要重新配置a2dp, 会强制切换speaker, 但由于没有中控, 导致数据传输堵塞, 无法进行下一步操作, 蓝牙无法接收到数据.  <-麻烦看下是否是此原因导

致.

多谢!

#6 - 2023-02-02 19:59 - CD BSP何伟

- Due date changed from 2023-01-19 to 2023-02-06

#7 - 2023-02-06 19:47 - CD BSP何伟

- Due date changed from 2023-02-06 to 2023-02-07

需要依赖中控环境去测试，但现在环境还有问题，需要先解决环境问题后再调查该问题

#8 - 2023-02-07 14:03 - CDTS-TEST 周婷

- Due date deleted (2023-02-07)

等待中控环境调整完成继续调查

#9 - 2023-02-14 10:56 - CDTS-TEST 周婷

- Due date set to 2023-02-21

#10 - 2023-02-17 09:53 - CD TPM-王祥林

- Target version set to VC1_FSE_0078_20230228

#11 - 2023-02-22 10:35 - CDTS-TEST 周婷

- Due date changed from 2023-02-21 to 2023-02-23

#12 - 2023-02-28 13:56 - CDTS-TEST 周婷

- Due date deleted (2023-02-23)

请重新确认解决时间

#13 - 2023-02-28 14:22 - CD TPM-王祥林

- Target version changed from VC1_FSE_0078_20230228 to VC1_FSE_0082_20230314

#14 - 2023-03-08 10:23 - CD BSP-杜磊

- Assignee changed from CD BSP何伟 to Multimedia组-RD3_TSCD 梁卿山

#15 - 2023-03-08 10:32 - CD BSP-杜磊

- Assignee changed from Multimedia组-RD3_TSCD 梁卿山 to CD BSP-唐金泽

#16 - 2023-03-23 11:38 - CD BSP-唐金泽

- Category changed from BSP to AUDIO-FW

- Status changed from ASSIGNED to RESOLVED

- Assignee changed from CD BSP-唐金泽 to CDTS_TEST 王成
hi 王成

我这验证没有复现，请安排相应同事进行检测；

怀疑近期BT代码优化，已经解决该问题。

#17 - 2023-03-23 11:38 - CD BSP-唐金泽

- Resolution set to INVALID

- Root cause set to 未复现

#18 - 2023-03-23 11:46 - CDTS_TEST 王成

- Assignee changed from CDTS_TEST 王成 to CD Test赵飞

#19 - 2023-03-23 14:30 - CDTS_TEST 王成

- Target version changed from VC1_FSE_0082_20230314 to VC1_FSE_0086_20230328

#20 - 2023-03-27 19:23 - CD Test赵飞

- % Done changed from 0 to 80

验证版本：FlatBuild_HH_MCE_FSE.M.D.user.01.00.C102.202303260013

验证结果：PASS

偶现问题，继续跟踪2个版本

#21 - 2023-03-29 10:45 - CD Test赵飞

验证版本：FlatBuild_HH_MCE_FSE.M.R.user.01.00.0086.C102

验证结果：PASS

偶现问题，继续跟踪1个版本

#22 - 2023-04-03 10:49 - CD Test赵飞

- Status changed from RESOLVED to VERIFIED

验证版本：FlatBuild_HH_MCE_FSE.M.D.user.01.00.C102.202304010020

验证结果：PASS

已跟踪3个版本不复现，关闭此问题

#23 - 2023-04-03 10:49 - CD Test赵飞

- Status changed from VERIFIED to CLOSED

- % Done changed from 80 to 100

#24 - 2023-04-24 13:45 - CDTS_TEST 王成

- Assignee changed from CD Test赵飞 to CD TPM-王祥林

麻烦看看这个BUG是否需要再次跟踪处理

Files

logcat_BT_unplay_music.txt 16.5 MB 2023-01-03 CDTS_TEST 刘勇
